#include <gnome.h>
#include	<stdio.h>
#include	<signal.h>
#include	<sys/wait.h>
#include	<fcntl.h>

GtkWidget	*app, *less;
int			fd[2];
FILE		*stream = NULL;

gchar	pdata[300];

gboolean	m_loop( gpointer aze )
{
	while( fgets( pdata, 300, stream ) )
	{	printf( "parent : " );
		printf( "%s", pdata );
		gtk_text_insert( GTK_TEXT( GNOME_LESS( less )->text ), NULL, NULL, NULL, 
			pdata, strlen( pdata ) );
	}

	
	printf( "end loop\n");
	return( TRUE );
}



int	main(int argc,char *argv[])
{
pid_t		pid = 0, ppid = getpid();

	gnome_init( "azreyui","123",argc,argv );
	
	app = gnome_app_new( "je sais pas...", "areuh" );
  	gnome_app_set_contents( GNOME_APP( app ), ( less = gnome_less_new() ) );
	
	// prevent zombie
	signal( SIGCHLD, SIG_IGN );

	// NOTA : using popen would be a great idea. Infortunly, with this function
	// there no way ( i think ) to get the pid process owning the streamed data...
	// must use the boring-classic solution
	
	if( pipe( fd ) )
	{	g_warning( "error creating pipe... abort" );
		exit( 1 );
	}
	
	if( !( pid = fork() ) )
	{	// child process
		gchar	*list[30];					// must be enough
		guint	count = 0;
		
		// use one pipe from child ( asfrecord3 ) to parent ( plugin
		dup2( fd[ 1 ], 1 );
		close( fd[ 0 ] );

		list[ count++ ] = "./pingpong";
		list[ count++ ] = "FILE";
		list[ count++ ] = "500";
		list[ count++ ] = "1";
		list[ count++ ] = "pingpong.data";
		list[ count++ ] = "";
		list[ count ] = NULL;
		
		// set to background directly, if gsfdm crash, still download...
		setpgid( 0, ppid );
		setsid();

		// disable local support, comme back to eng.
		putenv( "LC_ALL=C" );
		
		// execute		
		execvp( list[ 0 ], list );
		exit( -1 );							// exit on error
	}		
	
	// error in fork ???
	if( pid < 0 )
	{	g_warning( "error starting pong command... abort" );
		exit( 1 );		
	}
	
	close( fd[ 1 ] );
	fcntl( fd[ 0 ], F_SETFL, O_NONBLOCK );
	stream = fdopen( fd[ 0 ], "r" );	
//	setvbuf( stream, stream_buffer, _IONBF, BUFSIZ );

	gtk_timeout_add( 250, (GtkFunction)m_loop, NULL );
	
	gtk_widget_show_all( app );

	gtk_main();
	return( 0 );
}
