#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <string.h>
#include <regex.h>
#include <stdio.h>

#define regmain "[[:blank:]]*<[[:blank:]]*ASX[^<>]*>(.*)<[[:blank:]]*/ASX[[:blank:]]*>[[:blank:]]*"
#define regentry "(.*)<[[:blank:]]*ENTRY[[:blank:]]*>(.*)<[[:blank:]]*/ENTRY[[:blank:]]*>[[:blank:]]*"
#define	regref "(.*)<[[:blank:]]*REF[[:blank:]]+HREF[[:blank:]]*=[[:blank:]]*\"[[:blank:]]*(.*)\"[[:blank:]]*/[[:blank:]]*>[[:blank:]]*"

#define REG_A "\
<ASX VERSION=\"3.0\"> \
 <ENTRY> \
  <REF HREF=\"mms://a992.v21895.c2189.g.vm.akamaistream.net/7/992/2189/v0001/zap2it.download.akamai.com/2189/archive/wb/0202/wb_angel_020218_hi.asf\" /> \
 </ENTRY> \
</ASX>"

#define REG_C "  < ASX VERSION \"3\">  \
	<ENTRY >     \
		<REF HREF=\"mms://a992.v2189\" /> \
		<REF HREF=\"mms://a993\" /> \
		<REF HREF=\"mms://a994\" /> \
	<      /ENTRY		> \
	<   ENTRY>\
		<REF HREF=\"mms://4\" /> \
		<REF HREF=\"mms://5\" / > \
		<REF HREF=\"mms://6\"   /	> \
	</ENTRY> </ASX> "

main( int argc, gchar *argv[] )
{
regex_t 	*regMAIN  = g_new0( regex_t, 1 );
regex_t 	*regENTRY = g_new0( regex_t, 1 );
regex_t 	*regREF = g_new0( regex_t, 1 );
regmatch_t	m[10];
regmatch_t	m_entry[10];
regmatch_t	m_ref[10];
gchar		*str = REG_A;
	
	
	if( regcomp( regMAIN, regmain, REG_ICASE | REG_EXTENDED ) )
	{	g_print( "main compile pas...\n");
		exit( 255 );
	}

	if( regcomp( regENTRY, regentry, REG_ICASE | REG_EXTENDED ) )
	{	g_print( "entry start compile pas...\n");
		exit( 255 );
	}
	
	if( regcomp( regREF, regref, REG_ICASE | REG_EXTENDED ) )
	{	g_print( "ref compile pas...\n");
		exit( 255 );
	}
	
	if( argc > 1 )
	{	FILE	*f = fopen( argv[1], "r" );
		
		str = (gchar *)malloc( 1000 );
		fread( str, sizeof( gchar ), 1000, f );
		fclose( f );
	}
	
	g_print( "dump :\n%s\n-----------\n", str );
	
	if( !regexec( regMAIN, str, 10, m, 0 ) )
	{	gchar	*entry_str = g_strndup( str + m[1].rm_so, m[1].rm_eo - m[1].rm_so );
		regmatch_t	m_entry[10];

		while(!regexec( regENTRY, entry_str, 10, m_entry, 0 ) )
		{	gchar *work_str = g_strndup( entry_str + m_entry[2].rm_so, m_entry[2].rm_eo - m_entry[2].rm_so );
			
			g_print( "entry :: %s\n-----------\n", work_str );
			
			while( !regexec( regREF, work_str, 10, m_ref, 0 ) )
			{	g_print( "URL :: %s\n", g_strndup( work_str + m_ref[2].rm_so, m_ref[2].rm_eo - m_ref[2].rm_so ) );
				work_str[ m_ref[1].rm_eo + 1 ] = 0;
			}
			
			g_free( work_str );
			entry_str[ m_entry[1].rm_eo + 1 ] = 0;			
		}
			
		
	}
	 

}