/************************************************************************/

//			Gsfdm : a gnome stream file downloader

//				E-mail : j.a.l @ free.fr

//		Header for main operations : main "gnome" window manipulation

/************************************************************************/

#ifndef	GSFDM_MAIN
#define	GSFDM_MAIN

#include	<gnome.h>

/************************************************************************/
//	structure and define definition
/************************************************************************/
typedef enum {										// to inform main
	MAIN_UNDOCK,									// win of dock, undock
	MAIN_DOCK										// of some part
} MainDockOp;

// i hate working with numerical...
typedef enum {
	MAIN_HIDE,
	MAIN_SHOW
} MainShowHideOp;

typedef enum {										// type of dock !
	MAIN_DOCK_URL_LIST,
	MAIN_DOCK_INFO,
	MAIN_DOCK_MESSAGE
} MainDockItem;

// define how to exit
typedef enum {
	MAIN_EXIT_ANYWAY,								// close and kill of running job(s)
	MAIN_EXIT_BACKGROUND,							// close and let running job(s) in background
	MAIN_EXIT_SAFE,									// close when all SCHEDULED job(s) have been done ( auto_d )
	MAIN_EXIT_SHUTDOWN_PPPD,						// ... and close ( try to ) the pppd connextion / demon
	MAIN_EXIT_SHUTDOWN_HOST							// ... and stop the host ( just root user... )
} MainExitMode;

/************************************************************************/
//	functions definition
/************************************************************************/
//	write / push message into the status bar
//void	app_write_message( gchar const *message )
#define gsfdm_main_write_message( message ) ( gnome_appbar_push( status_bar, message ) )

/************************************************************************/
//	this is an internal callback, telling that the "url" block has no more job to 
// perform ---> warm user ( if configurated ) or close
void	gfsdm_main_job_stack_empty( void );

/************************************************************************/
// perform dock / undock op on part / window of main app
gboolean	gsfdm_main_dock_op( MainDockItem item );
// and for hiding some
gboolean	gsfdm_main_showhide_op( MainDockItem item );

/************************************************************************/
// inform on the dock state of a sub dock
gboolean	gsfdm_main_dock_op_get_dock_state( MainDockItem item );
//	and the show state
gboolean	gsfdm_main_dock_op_get_hide_state( MainDockItem item );

gboolean	gsfdm_main_get_allow_auto_dl( void );


#endif	GSFDM_MAIN
