// intented for test of plugin,  
// if arg, use first as data - text- file 
// else update string every TIMEOUT and exit after LOOP_MAX loop

//pingpong <mode> <timeout> <exit> [data file / or # of loop]   your arg...
// mode = FILE : use a data file
//		anything_else : send an internal string, with # of loop

// timeout : ms between every send
// exit :	: 0 --> don't exit at end
//		anything_else : auto exit at end of file or end of loop

// path to your file or # of loop

#include <glib.h>
#include <string.h>
#include <errno.h>
#include <stdio.h>
#include <time.h>

#define		BUFFER_LENGTH 1000

#define		ECHO			"blablabla.... blabla"
#define		THIS_IS_THE_END "job successful"


//*********************************************************************
int	main( int argc, char *argv[] )
{
gboolean	with_file = FALSE;
FILE		*f;
FILE		*input = NULL;
guint		length = BUFFER_LENGTH;
gchar		*buffer = NULL;
guint		timeout;
guint		loop_count;
clock_t		last;
guint		count = 0;	
	
	if( !( f = fopen( "/dev/console", "w+" ) ) )
		exit( 255 );
	
	if( argc < 2 )
	{	printf( "pingong <mode : FILE / LOOP> <timeout (ms)> <auto_exit 1 / 0> < datafile / loop count >\n");
		exit( 0 );
	}

	// dump of arg
	fprintf( f, "Pingpong started, %d arg\n", argc );
	while( argv[ count++] )
		fprintf( f, "%s\n", argv[count] );
	
	buffer = g_new0( gchar, length );
	timeout = atoi( argv[2] );	
	
	// if arg, open a file to read data from
	if( !strcmp( argv[1], "FILE"  ) )
	{	// use a file for data
		
		if( !( input = fopen( argv[4], "r" ) ) )
		{	fprintf( f, "can't load file.. abort\n");
			fclose( f );
			exit( 255 );
		}
		
		with_file = TRUE;
		
	} else {
		input = NULL;
		loop_count = atoi( argv[4] );
		with_file = FALSE;
	}
		
	count = 0;
	while( last = clock(), TRUE )
	{	
		// wait
		while( (guint)( (gdouble)( clock() - last ) * ( 1000.0 / CLOCKS_PER_SEC ) ) < timeout );
		
		if( with_file )
		{
			if( feof( input ) )	
			{	fprintf( f, "%s", THIS_IS_THE_END );
				break;
			}
	
			getline( &buffer, &length, input );
			fprintf( f, " pingpong.. ||| %s", buffer );
			fprintf( stdout, "%s", buffer );
			fflush( stdout );

			
		// with a counter and internal string
		} else {

			if( count++ > loop_count )
			{
				fprintf( f, "%s", THIS_IS_THE_END );
				break;
			}
	
			fprintf( f, " pingpong.. loop %d, %s\n", count, ECHO );
			fprintf( stdout, " pingpong.. loop %d, %s\n", count, ECHO );
			fflush( stdout );
		}
		
	}
	
	fprintf( f, "FINI...\n" );

	// clean
	if( input )
		fclose( input );
	fclose( f );
	if( buffer )
		g_free( buffer );
	
	// should i quit ???
	if( !strcmp( argv[3], "0" ) )
		while( TRUE );			// no
	
	return( 0 );
}


