/************************************************************************/

//			Gsfdm : a gnome stream file downloader

//				E-mail : j.a.l @ free.fr

//		Header for displaying info on the current / last highlighted url

/************************************************************************/

#ifndef	GSFDM_INFO
#define	GSFDM_INFO

#include	<gnome.h>

/************************************************************************/
//	structure and define definition
/************************************************************************/

/************************************************************************/
//	functions definition
/************************************************************************/
// return the top widget of the info box
GtkWidget const	*gsfdm_info_get_dock( void );

/************************************************************************/
// display info for this id, if 0, clear
void	gsfdm_info_display_info( gint entry_id );

/************************************************************************/
// infor that this id is no more selected
void	gsfdm_info_undisplay_info( gint entry_id );

/************************************************************************/
// infor the info "block" that the state, data for this id has just changed
void	gsfdm_info_inform_for_change( gint entry_id );

/************************************************************************/
// infor the info "block" that this id has been deleted from list
void	gsfdm_info_inform_for_deleted( gint entry_id );

/************************************************************************/
// infor the info "block" that the running filed for this id has been updated
void	gsfdm_info_inform_on_update( gint entry_id );

#endif	GSFDM_INFO
