/************************************************************************/

//			Gsfdm : a gnome stream file downloader

//				E-mail : j.a.l @ free.fr

//		Header for opening and manipulate the log file

/************************************************************************/

#ifndef	GSFDM_LOG
#define	GSFDM_LOG

#include	<gnome.h>

/************************************************************************/
//	structure and define definition
/************************************************************************/

/************************************************************************/
//	functions definition
/************************************************************************/
// init param, open log file... save some test, some cpu time
// FALSE if aneable to init ( e.i. open stream )
// load the config also
gboolean	gsfdm_log_init( void );
#define		gsfdm_log_load_config() ( gsfdm_log_init() )

/************************************************************************/
// close ( e.i. close stream ) and save config
void		gsfdm_log_close( void );
#define 	gsfdm_log_save_config() ( gsfdm_log_close() )

/************************************************************************/
// return the widget containing log config
GtkWidget	*gsfdm_log_get_config_page( void );

/************************************************************************/
// add a line to the log file
void	gsfdm_log_push_line( gchar const *data );

/************************************************************************/
// open the log file dlg
void	gsfdm_log_open( void );

#endif	GSFDM_LOG
