/************************************************************************/

//			Gsfdm : a gnome stream file downloader

//				E-mail : j.a.l @ free.fr

//		Header for message box

/************************************************************************/

#ifndef	GSFDM_MESSAGE
#define	GSFDM_MESSAGE

#include	<gnome.h>
#include	"gsfdm_url.h"

/************************************************************************/
//	structure and define definition
/************************************************************************/
// there some defined messages... some only apply to message window, other 
// also to status bar, log file....
#define	MESS_BASE_EXIT_CODE 100

typedef enum {
	MESS_START_DOWNLOAD,				// infor of start downloading ; *st_gsfdm_url_entry
	MESS_FINISH_DOWNLOAD,				// ... ; *st_gsfdm_url_entry
	MESS_DOWNLOAD_STOPPED,				// user cancel the download ; *st_gsfdm_url_entry
	MESS_DEAD_LINK,						// tried but dead link ; *st_gsfdm_url_entry
	MESS_ERROR,							// somthing wrong.
	MESS_PARTIAL_LINK,					// stopped, not finished ; *st_gsfdm_url_entry
	MESS_UNKNOW_PROTOCOL,				// tried to download something unknow ; gchar *proto
	MESS_DISMISS,						// dismiss this file / url from downloading
	
	MESS_NO_PLUGIN,						// sprinted when try to add something unknow
	MESS_AUTO_DOWNLOAD,					// when global auto download is switched ; gboolean
	
	MESS_NO_PPPD,						// warm user pppd is not running, so no download
	MESS_PATH_CHANGED,					// automatically changed a worng path
	
	MESS_BEGIN,							// begin a new session
	MESS_EXIT,							// push an exit message ( real exit ) ; no data

	MESS_EXIT_ANYWAY = MESS_BASE_EXIT_CODE,	// here code to infor own we exit ; no data
	MESS_EXIT_BACKGROUND,				
	MESS_EXIT_PUSH_IN_BACK,
	MESS_EXIT_SAFE,			
	MESS_EXIT_SHUTDOWN_PPPD,
	MESS_EXIT_SHUTDOWN_HOST		
} GsfdmMessageCode;

/************************************************************************/
//	functions definition
/************************************************************************/
// return the main message widget
GtkWidget	*gsfdm_message_get_dock( void );

/************************************************************************/
// add a line to the message
// could add the time / date ; to the app message bar, and could add to log file
void		gsfdm_message_push_message( gchar const *message, gboolean print_date, gboolean status, gboolean push_log );

/************************************************************************/
//	write a defined message, with and optionnal data
void		gsfdm_message_push_code( GsfdmMessageCode c, gpointer data );

#endif	GSFDM_MESSAGE
